//
//  AWAddTaskViewController.m
//  OverdueAssignment
//
//  Created by Andrew Weiss on 11/7/13.
//  Copyright (c) 2013 Andrew Weiss. All rights reserved.
//

#import "AWAddTaskViewController.h"

@interface AWAddTaskViewController ()

@end

@implementation AWAddTaskViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    self.taskDescriptionTextView.delegate = self;
    
    [self updateuUI];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)addTaskButtonPressed:(UIButton *)sender
{
    [self.delegate didAddTask:[self formToTask]];
}

- (IBAction)cancelButtonPressed:(UIButton *)sender
{
    [self.delegate didCancel];
}

#pragma mark - UITextViewDelegate Methods

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text
{
    if ([text isEqualToString:@"\n"]) {
        [self.taskDescriptionTextView resignFirstResponder];
        return NO;
    }
    
    return YES;
}

-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    [[self view] endEditing:YES];
}

#pragma mark - Helper Methods

- (void)updateuUI
{
    self.taskDescriptionTextView.layer.backgroundColor = [[UIColor whiteColor] CGColor];
    self.taskDescriptionTextView.layer.borderColor = [[UIColor grayColor] CGColor];
    self.taskDescriptionTextView.layer.borderWidth = 1;
    self.taskDescriptionTextView.layer.masksToBounds = NO;
    self.taskDescriptionTextView.layer.shadowColor = [[UIColor blackColor] CGColor];
    self.taskDescriptionTextView.layer.shadowOffset = CGSizeMake(1.5f, 1.5f);
    self.taskDescriptionTextView.layer.shadowOpacity = 0.3f;
    self.taskDescriptionTextView.layer.shadowRadius = 1.0f;
    
    self.taskTitleTextField.layer.backgroundColor = [[UIColor whiteColor] CGColor];
    self.taskTitleTextField.layer.borderColor = [[UIColor grayColor] CGColor];
    self.taskTitleTextField.layer.borderWidth = 1;
    self.taskTitleTextField.layer.masksToBounds = NO;
    self.taskTitleTextField.layer.shadowColor = [[UIColor blackColor] CGColor];
    self.taskTitleTextField.layer.shadowOffset = CGSizeMake(1.5f, 1.5f);
    self.taskTitleTextField.layer.shadowOpacity = 0.3f;
    self.taskTitleTextField.layer.shadowRadius = 1.0f;
}

- (AWTask *)formToTask
{
    NSDictionary *taskItem = @{TITLE : self.taskTitleTextField.text, DESCRIPTION : self.taskDescriptionTextView.text, DATE : self.taskDate.date, COMPLETION : @NO};
    AWTask *task = [[AWTask alloc] initWithData:taskItem];
    return task;
}


@end
