//
//  AWDetailTaskViewController.m
//  OverdueAssignment
//
//  Created by Andrew Weiss on 11/7/13.
//  Copyright (c) 2013 Andrew Weiss. All rights reserved.
//

#import "AWDetailTaskViewController.h"

@interface AWDetailTaskViewController ()

@end

@implementation AWDetailTaskViewController

#pragma mark - Default UIViewController Methods

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    [self updateUI];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - IBAction Methods

- (IBAction)editTaskBarButtonItemPressed:(UIBarButtonItem *)sender
{
    [self performSegueWithIdentifier:@"toAWEditTaskViewControllerSegue" sender:sender];
}

#pragma mark - Navigation and Segues

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([sender isKindOfClass:[UIBarButtonItem class]] && [segue.destinationViewController isKindOfClass:[AWEditTaskViewController class]]) {
        AWEditTaskViewController *editTaskViewController = segue.destinationViewController;
        editTaskViewController.selectedTask = self.selectedTask;
        editTaskViewController.delegate = self;
    }
}

#pragma mark - AWEditTaskViewControllerDelegate Methods

- (void)didEditTask:(AWTask *)task
{
    [self updateUI];
    [self.delegate didFinishEditingTask:task atIndexPath:self.selectedTaskIndexPath];
}

#pragma mark - Helper Methods

- (void)updateUI
{
    self.taskTitleLabel.text = self.selectedTask.title;
    self.taskDetailsLabel.text = self.selectedTask.description;
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"MM-dd-yyyy"];
    self.taskDueDateLabel.text = [@"Due date: " stringByAppendingString:[dateFormatter stringFromDate:self.selectedTask.date]];
}

@end
