//
//  AWEditTaskViewController.m
//  OverdueAssignment
//
//  Created by Andrew Weiss on 11/7/13.
//  Copyright (c) 2013 Andrew Weiss. All rights reserved.
//

#import "AWEditTaskViewController.h"

@interface AWEditTaskViewController ()

@end

@implementation AWEditTaskViewController

#pragma mark - Default UIViewController Methods

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    self.taskDescriptionTextView.delegate = self;
    
    [self updateUI];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - IBAction Methods

- (IBAction)saveTaskBarButtonItemPressed:(UIBarButtonItem *)sender
{
    self.selectedTask.title = self.taskTitleTextField.text;
    self.selectedTask.description = self.taskDescriptionTextView.text;
    self.selectedTask.date = self.taskDueDatePicker.date;
    [self.delegate didEditTask:self.selectedTask];
    [self.navigationController popViewControllerAnimated:YES];
}

#pragma mark - UITextViewDelegate Methods

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text
{
    if ([text isEqualToString:@"\n"]) {
        [self.taskDescriptionTextView resignFirstResponder];
        return NO;
    }
    
    return YES;
}

#pragma mark - Helper Methods

- (void)updateUI
{
    self.taskTitleTextField.text = self.selectedTask.title;
    self.taskDescriptionTextView.text = self.selectedTask.description;
    self.taskDueDatePicker.date = self.selectedTask.date;
}

@end
